#include <sys/socket.h>
#include <sys/types.h>

#include <arpa/inet.h>
#include <netinet/in.h>

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MAXLINE 1024

int main(int argc, char *argv[])
{
	unsigned char line[MAXLINE + 1];
	struct sockaddr_in servaddr;
	char *ip_address = "127.0.0.1";
	int port = 13;
	int sockfd, n;

	servaddr.sin_family = AF_INET;
	servaddr.sin_port   = htons(port);

	n = inet_pton(AF_INET, ip_address, &servaddr.sin_addr);
	if (n < 0) {
		perror("inet_pton");
		exit(1);
	}
	else if (n == 0) {
		fprintf(stderr, "invalid address %s", ip_address);
		exit(1);
	}

	if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("socket");
		exit(1);
	}
	
	if (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0) {
		perror("connect");
		exit(1);
	}

	for ( ; ; ) {
		n = read(sockfd, line, MAXLINE);
		if (n < 0) {
			perror("read");
			exit(1);
		}
		else if (n == 0) {
			printf("EOF\n");
			break;	
		}
		line[n] = '\0'; /* string termination */
		printf("%s\n", line);
	}
	
	if (close(sockfd) < 0) {
		perror("close");
		exit(1);
	}

	return 0;
}
